#define __MSC__
#include <afxwin.h>
#include <stdio.h>
#include <math.h>
#include <malloc.h>
#include <string.h>
#include <glide.h>
typedef unsigned short int UWORD;
typedef unsigned long int UDWORD;
#define DEG2RAD(x) (x*3.1415927f/180.0f)
#define Z_SCALE 512
#define ZVIEWER 300
#define PI 3.14157f
#define TUNNEL_DEPTH 90
#define TUNNEL_LEVEL_DEPTH (600.0f/7.0f*2)
#define ampliY1 170
#define ampliX1 170
const float vertsnap=(float)(3L<<18);

/* here comes the global variables for setup */
int setupTex=0;		/* 0..1 -> giger03 or O3dfx texture */
int setupSpeed=20;	/* speed -> the higher, the faster (20 is a good value) */


void translate(GrVertex *pInVertex,GrVertex *pOutVertex,float dx,float dy,float dz);
void demoCopyVertex(GrVertex *InVertex,GrVertex *OutVertex);
void initFPU(void);
void initTunnel(void);

GrHwConfiguration hw;
extern BOOL bRunning;		/* this one gets set by the calling thread */

/**********************************************************************************************************/
/* that's the tunnels basic shape, an regular octa-thinggy :-) */
struct TUNNEL
{
	GrVertex vertex[9];
}	
	tunnelProto=
	{{
		{-200.0f,-600.0f/7.0f},
		{-600.0f/7.0f,-200.0f},
		{600.0f/7.0f,-200.0f},
		{200.0f,-600.0f/7.0f},
		{200.0f,600.0f/7.0f},
		{600.0f/7.0f,200.0f},
		{-600.0f/7.0f,200.0f},
		{-200.0f,600.0f/7.0f},
		{-200.0f,-600.0f/7.0f}
	}};
TUNNEL tunnel[TUNNEL_DEPTH],tunnel1[TUNNEL_DEPTH]; /* a complete tunnel and a copy of it */
int	ti[TUNNEL_DEPTH];	/* tunnel-index (order of the tunnel-segments [those octaXXX, remember?])
/********************************************************************************************************/

int SSaver_Main(void* hwnd)
{
	int i,j,k;		/* counters */
	int count=0;	/* ;-) */
	Gu3dfInfo	fileInfo;
	char	filename[2][32]={
		"giger03.3df",
		"o3dfx.3df"};
	FxU32	texSize,startAddress;	/* size of the texture, startadress of the texture in texmem */
	GrTexInfo	texInfo;

//init
	initTunnel();	
	initFPU();
	grGlideInit();
	if (!grSstQueryHardware(&hw)) MessageBox(NULL,"ERROR: (SSaver_Main) No Voodoo Graphics detected!\n","ERROR!",MB_OK);
	grSstSelect(0);

/* change this for screensaver */
	hwnd=GetActiveWindow();
	
/* all kinds of setup stuff, mostly copied from the manual ;-) */
	grSstWinOpen((FxU32)hwnd,GR_RESOLUTION_640x480,GR_REFRESH_60Hz,GR_COLORFORMAT_ABGR,GR_ORIGIN_LOWER_LEFT,2,1);
	gu3dfGetInfo(filename[setupTex],&fileInfo);
	fileInfo.data=malloc(fileInfo.mem_required);
	gu3dfLoad(filename[setupTex],&fileInfo);
	texInfo.smallLod=GR_LOD_1;
	texInfo.largeLod=GR_LOD_256;
	texInfo.aspectRatio=GR_ASPECT_1x1;
	texInfo.format=GR_TEXFMT_ARGB_1555;
	texInfo.data=fileInfo.data;
	texSize=grTexTextureMemRequired(GR_MIPMAPLEVELMASK_BOTH,&texInfo);
	startAddress=grTexMinAddress(GR_TMU0);
	grTexDownloadMipMap(GR_TMU0,startAddress,GR_MIPMAPLEVELMASK_BOTH,&texInfo);
	grTexSource(GR_TMU0,startAddress,GR_MIPMAPLEVELMASK_BOTH,&texInfo);
	grTexCombine(GR_TMU0,GR_COMBINE_FUNCTION_LOCAL,GR_COMBINE_FACTOR_NONE,GR_COMBINE_FUNCTION_LOCAL,
					GR_COMBINE_FACTOR_NONE,FXFALSE,FXFALSE);
	grTexClampMode(GR_TMU0,GR_TEXTURECLAMP_WRAP,GR_TEXTURECLAMP_WRAP);
	grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER,GR_COMBINE_FACTOR_LOCAL,GR_COMBINE_LOCAL_CONSTANT,GR_COMBINE_OTHER_TEXTURE,FXFALSE);
	grCullMode(GR_CULL_NEGATIVE);grDepthBufferMode(GR_DEPTHBUFFER_WBUFFER);grDepthBufferFunction(GR_CMP_LESS);grDepthMask(FXTRUE);
	grFogColorValue(0xffffff);
	grFogMode(GR_FOG_WITH_ITERATED_ALPHA);

/* mainloop */
/* if you are into optimizing, don't go any further or you will experience a heart attack */
	do
	{
		count+=setupSpeed;
		if (count>=(TUNNEL_LEVEL_DEPTH*TUNNEL_DEPTH))	/* end of period? */
		{
			initTunnel();		// yes, back to where we started
			count=setupSpeed;
		}
		grBufferClear(0,0,GR_WDEPTHVALUE_FARTHEST);		// clear screen
		if ((tunnel[ti[0]].vertex[0].z+ZVIEWER-50-count)<=0)	// is first segment close enough ??
		{
			for (i=0;i<9;i++)	// yes, put it at the end of the tunnel
				tunnel[ti[0]].vertex[i].z=tunnel[ti[TUNNEL_DEPTH-1]].vertex[i].z+(TUNNEL_LEVEL_DEPTH);
			int dummy=ti[0];
			for (i=0;i<(TUNNEL_DEPTH-1);i++)
				ti[i]=ti[i+1];
			ti[TUNNEL_DEPTH-1]=dummy;
		}
		memcpy(tunnel1,tunnel,sizeof(TUNNEL)*TUNNEL_DEPTH);	// dont try this at home!!!!!! 
		for (j=0;j<TUNNEL_DEPTH;j++)
			for (i=0;i<9;i++)
			{
				// move and twist the tunnel
				translate(&tunnel[ti[j]].vertex[i],&tunnel1[ti[j]].vertex[i],
					(float)-(cos(DEG2RAD(count/TUNNEL_LEVEL_DEPTH*20))*ampliX1),
					(float)-(sin(DEG2RAD(count/TUNNEL_LEVEL_DEPTH*20))*ampliY1),(float)-count);
				// perspective correction stuff
				tunnel1[ti[j]].vertex[i].oow=1.0f/(tunnel1[ti[j]].vertex[i].z+ZVIEWER);
				tunnel1[ti[j]].vertex[i].tmuvtx[0].oow=tunnel1[ti[j]].vertex[i].oow;
				tunnel1[ti[j]].vertex[i].x=(Z_SCALE*tunnel1[ti[j]].vertex[i].x*tunnel1[ti[j]].vertex[i].oow)+320.0f;
				tunnel1[ti[j]].vertex[i].y=(Z_SCALE*tunnel1[ti[j]].vertex[i].y*tunnel1[ti[j]].vertex[i].oow)+240.0f;
				tunnel1[ti[j]].vertex[i].a=(tunnel1[ti[j]].vertex[i].z/50); //fog
				//snap to 0.0625 precision
				tunnel1[ti[j]].vertex[i].x+=vertsnap;tunnel1[ti[j]].vertex[i].x-=vertsnap;
				tunnel1[ti[j]].vertex[i].y+=vertsnap;tunnel1[ti[j]].vertex[i].y-=vertsnap;
			}
		// texture setup
		for (j=0;j<TUNNEL_DEPTH;j++)
			for (i=0;i<8;i++)
			{
				k=(j==(TUNNEL_DEPTH-1))?0:j+1;
				tunnel1[ti[j]].vertex[i].tmuvtx->sow=0*tunnel1[ti[j]].vertex[i].oow;
				tunnel1[ti[j]].vertex[i].tmuvtx->tow=255*tunnel1[ti[j]].vertex[i].oow;
				tunnel1[ti[j]].vertex[i+1].tmuvtx->sow=255*tunnel1[ti[j]].vertex[i+1].oow;
				tunnel1[ti[j]].vertex[i+1].tmuvtx->tow=255*tunnel1[ti[j]].vertex[i+1].oow;
				tunnel1[ti[k]].vertex[i].tmuvtx->sow=0*tunnel1[ti[k]].vertex[i].oow;
				tunnel1[ti[k]].vertex[i].tmuvtx->tow=0*tunnel1[ti[k]].vertex[i].oow;
				tunnel1[ti[k]].vertex[i+1].tmuvtx->sow=255*tunnel1[ti[k]].vertex[i+1].oow;
				tunnel1[ti[k]].vertex[i+1].tmuvtx->tow=0*tunnel1[ti[k]].vertex[i+1].oow;
				guDrawTriangleWithClip(&tunnel1[ti[j]].vertex[i],&tunnel1[ti[j]].vertex[i+1],&tunnel1[ti[k]].vertex[i+1]);
				guDrawTriangleWithClip(&tunnel1[ti[j]].vertex[i],&tunnel1[ti[k]].vertex[i+1],&tunnel1[ti[k]].vertex[i]);
			}
		while (grBufferNumPending());
		grBufferSwap(1);
	}	while (bRunning);	// still running??
	grGlideShutdown();
	return 0;
}

/**********************************************************************************************************/
/**********************************************************************************************************/
/**********************************************************************************************************/

void initTunnel(void)
{
	int i,j;
	for (i=0;i<TUNNEL_DEPTH;i++)
	{
		ti[i]=i;
		memcpy(&tunnel[i],&tunnelProto,sizeof(TUNNEL));
		for (j=0;j<9;j++) 
		{
			tunnel[i].vertex[j].z=i*TUNNEL_LEVEL_DEPTH;
			tunnel[i].vertex[j].y=tunnelProto.vertex[j].y+(float)(sin(DEG2RAD(i*20))*ampliY1);
			tunnel[i].vertex[j].x=tunnelProto.vertex[j].x+(float)(cos(DEG2RAD(i*20))*ampliX1);
		}
	}
}

void initFPU(void)	// ->24bit precision
{	unsigned int dummy;
	_asm
	{	finit
		fwait
		fstcw	[dummy]
		fwait
		mov		eax,[dummy]
		and		eax,0fffffcffh
		mov		[dummy],eax
		fldcw	[dummy]
		fwait
	}
	return;
}

inline void translate(GrVertex *pInVertex,GrVertex *pOutVertex,float dx,float dy,float dz)
{
	pOutVertex->x=pInVertex->x+dx;
	pOutVertex->y=pInVertex->y+dy;
	pOutVertex->z=pInVertex->z+dz;
}

inline void demoCopyVertex(GrVertex *InVertex,GrVertex *OutVertex)
{
	OutVertex->x=InVertex->x;
	OutVertex->y=InVertex->y;
	OutVertex->z=InVertex->z;
	OutVertex->ooz=InVertex->ooz;
	OutVertex->oow=InVertex->oow;
	OutVertex->tmuvtx[0].oow=InVertex->tmuvtx[0].oow;
	OutVertex->tmuvtx[0].sow=InVertex->tmuvtx[0].sow;
	OutVertex->tmuvtx[0].tow=InVertex->tmuvtx[0].tow;
	OutVertex->a=InVertex->a;
	OutVertex->r=InVertex->r;
	OutVertex->g=InVertex->g;
	OutVertex->b=InVertex->b;
	return;
}

